module Parser
   where


import Tokenizer

singleWordQuote :: String -- ^ input string
                -> [String] -- ^ singleWordQuoteStarters
                -> String -- ^ pauseIndicators
                -> String -- ^ vowel
                -> String -- ^ consonants
                -> String -- ^ vowelModifiers
                -> String -- ^ singleWordQuote
singleWordQuote [] singleWordQuoteStarters pauseIndicators vowels consonants vowelModifiers = []
singleWordQuote aString [] pauseIndicators vowels consonants vowelModifiers = []
singleWordQuote aString singleWordQuoteStarters pauseIndicators vowels consonants vowelModifiers =
 let aWord = baseWord aString pauseIndicators vowels consonants vowelModifiers 
     nextWord = baseWord (drop (length aWord) aString) pauseIndicators vowels consonants vowelModifiers
     aSingleWordQuote = aWord ++ nextWord
  in if elem aWord singleWordQuoteStarters
     then aSingleWordQuote
     else ""

-- wordQuoteStarters = [["ku","bq"],["dq","ga"],["lu","lU"],["do","dO"],["m2","g!"],["lQ","Ta","gi"]]
wordQuote :: String -- ^ input string 
          -> String -- ^ pauseIndicators
          -> String -- ^ vowel
          -> String -- ^ consonants
          -> String -- ^ vowelModifiers
          -> [[String]] -- ^ wordQuoteStarters
          -> [String]   -- ^ stopQuoteStarters
          -> ([String],[(String,[String])])   -- ^ langQuoteStarters
          -> String -- ^ output lBQ-G! style quote
wordQuote aString [] vowels consonants vowelModifiers wordQuoteStarters stopQuoteStarters langQuoteStarters = []
wordQuote [] pauseIndicators vowels consonants vowelModifiers wordQuoteStarters stopQuoteStarters langQuoteStarters = []
wordQuote aString pauseIndicators vowels consonants vowelModifiers wordQuoteStarters stopQuoteStarters langQuoteStarters =
-- let theBlanks = getBlanks aString pauseIndicators
-- in
-- if (length theBlanks) > 0 
--  then theBlanks ++ wordQuote (drop (length theBlanks) aString) pauseIndicators vowels consonants vowelModifiers wordQuoteStarters stopQuoteStarters langQuoteStarters
--  else
   let theWord = baseWord aString pauseIndicators vowels consonants vowelModifiers
       theElems = wordQuoteDeepElems  theWord wordQuoteStarters
   in  multiQuote aString pauseIndicators vowels consonants vowelModifiers theElems wordQuoteStarters stopQuoteStarters langQuoteStarters

wordQuoteDeepElems :: String -- ^ input string
                 -> [[String]] -- ^ all delimiter groupings
                 -> [String] -- ^ output lBQ-G! style quote
wordQuoteDeepElems [] [] = []
wordQuoteDeepElems aWord [] = []
wordQuoteDeepElems [] allElems = []
wordQuoteDeepElems aWord (curElems:restElems) =
--   let curElems = allElems !! 0
--       restElems = tail allElems
--   in
   if elem aWord curElems
      then curElems
      else wordQuoteDeepElems aWord restElems

multiWordQuoteStarterElemCheck :: String -- ^ input string
          -> [[String]] -- ^ all delimiter groupings
          -> Bool -- ^ output lBQ-G! style quote
multiWordQuoteStarterElemCheck anElem [] = False
multiWordQuoteStarterElemCheck [] allElems = False -- error no first arg (even though empty set is a member)
multiWordQuoteStarterElemCheck anElem allElems =
   let curElems = allElems !! 0 !! 0
       restElems = tail allElems
   in
   if anElem == curElems
      then True
      else multiWordQuoteStarterElemCheck anElem restElems
-- lQuote :: String -- ^ input string
--        -> String -- ^ quote starter
--        -> String -- ^ quote ender
--        -> String -- ^ output parsed quote
-- lQuote aString starter ender = 
--    let theMonoSyllable = monoSyllable aString
--    in 
--    if theMonoSyllable == starter
--       then theMonoSyllable ++ tillEnd (drop (length starter) aString) ender
--       else ""

multiQuote :: String -- ^ input string
          -> String -- ^ pauseIndicators
          -> String -- ^ vowels
          -> String -- ^ consonants
          -> String -- ^ vowelModifiers
           -> [String] -- ^ delimiters
           -> [[String]] -- ^ wordQuoteStarters
           -> [String] -- ^ stopQuoteStarters
           -> ([String],[(String,[String])]) -- ^ langQuoteStarters
           -> String -- ^ full quote
multiQuote aString pauseIndicators vowels consonants vowelModifiers  [] wordQuoteStarters stopQuoteStarters langQuoteStarters = []
multiQuote []  pauseIndicators vowels consonants vowelModifiers delimiters wordQuoteStarters  stopQuoteStarters langQuoteStarters = []
multiQuote aString  pauseIndicators vowels consonants vowelModifiers delimiters wordQuoteStarters  stopQuoteStarters langQuoteStarters =
--  let theBlanks = getBlanks aString pauseIndicators 
--  in
--  if (length delimiters) <= 1
--     then [] -- end
--     else 
--      if (length theBlanks) > 0 
--       then theBlanks ++ multiQuote (drop (length theBlanks) aString) pauseIndicators vowels consonants vowelModifiers delimiters wordQuoteStarters stopQuoteStarters langQuoteStarters 
--       else
       let theWord = baseWord aString pauseIndicators vowels consonants vowelModifiers 
        --    theStopQuote = stopQuote aString stopQuoteStarters
        --    theLangQuote = langQuote aString langQuoteStarters stopQuoteStarters
           theDelim = head delimiters 
           theDelimiters = tail delimiters
           theContinuation =  multiQuoteContinuation (drop (length theWord) aString) pauseIndicators vowels consonants vowelModifiers delimiters wordQuoteStarters stopQuoteStarters langQuoteStarters  -- (tillEnd (drop (length x) aString) (head xs))
           theNextContinue = multiQuote (drop ((length theContinuation) - (length (theWord))) aString)  pauseIndicators vowels consonants vowelModifiers theDelimiters wordQuoteStarters stopQuoteStarters langQuoteStarters 
       in
       if theWord == theDelim
       then theWord ++ theContinuation -- ++ theNextContinue -- if length theDelimiters < 1
            -- then theWord ++ theContinuation ++ theNextContinue
            -- else theWord ++ theContinuation
          else "" 

multiQuoteContinuation :: String -- ^ input string
                       -> String -- ^ pauseIndicators
                       -> String -- ^ vowels
                       -> String -- ^ consonants
                       -> String -- ^ vowelModifiers
                       -> [String] -- ^ list of delimiters
                       -> [[String]] -- ^ wordQuoteStarters
                       -> [String] -- ^ stopQuoteStarters
                       -> ([String],[(String,[String])]) -- ^ langQuoteStarters
                       -> String -- ^ output the output up to and including the second delimiter
multiQuoteContinuation aString pauseIndicators vowels consonants vowelModifiers [] wordQuoteStarters stopQuoteStarters langQuoteStarters  = []
multiQuoteContinuation [] pauseIndicators vowels consonants vowelModifiers  delimiters wordQuoteStarters stopQuoteStarters langQuoteStarters  = []
multiQuoteContinuation aString  pauseIndicators vowels consonants vowelModifiers delimiters wordQuoteStarters stopQuoteStarters langQuoteStarters  =
--  let theBlanks = getBlanks aString pauseIndicators
--  in
--  if (length theBlanks) > 0 
--   then theBlanks ++ multiQuoteContinuation (drop (length theBlanks) aString) pauseIndicators vowels consonants vowelModifiers  delimiters wordQuoteStarters stopQuoteStarters langQuoteStarters 
--  else
   let theWord                  = baseWord aString  pauseIndicators vowels consonants vowelModifiers
       theStopQuote             = stopQuote aString  pauseIndicators vowels consonants vowelModifiers stopQuoteStarters
       theStopQuoteContinuation = multiQuoteContinuation (drop (length theStopQuote) aString) pauseIndicators vowels consonants vowelModifiers delimiters wordQuoteStarters stopQuoteStarters langQuoteStarters 
       theLangQuote             = langQuote aString pauseIndicators vowels consonants vowelModifiers stopQuoteStarters  langQuoteStarters
       theLangQuoteContinuation = multiQuoteContinuation (drop (length theLangQuote) aString) pauseIndicators vowels consonants vowelModifiers delimiters wordQuoteStarters stopQuoteStarters langQuoteStarters 
       theWordContinuation      = multiQuoteContinuation (drop (length theWord) aString) pauseIndicators vowels consonants vowelModifiers delimiters wordQuoteStarters stopQuoteStarters langQuoteStarters 
       multiQuoteNest           = multiQuote aString pauseIndicators vowels consonants vowelModifiers delimiters wordQuoteStarters stopQuoteStarters langQuoteStarters
       multiQuoteNestContin     = multiQuoteContinuation (drop (length multiQuoteNest) aString) pauseIndicators vowels consonants vowelModifiers delimiters wordQuoteStarters stopQuoteStarters langQuoteStarters
       --- theWordQuote             = wordQuote aString pauseIndicators vowels consonants vowelModifiers wordQuoteStarters stopQuoteStarters langQuoteStarters 
       --theWordQuoteContinuation = multiQuoteContinuation (drop (length theWordQuote) aString) pauseIndicators vowels consonants vowelModifiers delimiters wordQuoteStarters stopQuoteStarters langQuoteStarters 

   in -- if first delimeter 
   if length theWord == 0
      then []
      else 
       -- if multiWordQuoteStarterElemCheck theWord wordQuoteStarters
       --    --- then multiQuote aString
       --   then theWordQuote ++ theWordQuoteContinuation
       --    --- else if second delimiter 
       --   else 
       if theWord == delimiters !! 0
        then multiQuoteNest ++ multiQuoteNestContin
        else 
         if theWord == delimiters !! 1
          ---- then return end
          then theWord
          ---- else return and recurse
          -- check the stopQuote an langQuote
          else if elem theWord stopQuoteStarters
             then theStopQuote ++ theStopQuoteContinuation
             else if elem theWord $ fst langQuoteStarters
                then theLangQuote ++ theLangQuoteContinuation
                else theWord ++ theWordContinuation
    

--tillEnd :: String -- ^ input string
--         -> String -- ^ end of input
--         -> String -- ^ output first number string
--tillEnd [] [] = []
--tillEnd aString [] = []
--tillEnd [] theEnd = []
--tillEnd aString theEnd =
--   let thelBword = lBword aString
--   in 
--   if thelBword == theEnd
--      then thelBword
--      else thelBword ++ tillEnd (drop (length thelBword) aString) theEnd

-- | tanru many concatenated affixCompound or biSyllable
complexRootWord :: String -- ^ input string
                -> String -- ^ pauseIndicators
                -> String -- ^ vowels
                -> String -- ^ consonants
                -> String -- ^ vowelModifiers
                -> String -- ^ output tanru string
complexRootWord []  pauseIndicators vowels consonants vowelModifiers = []
complexRootWord aString pauseIndicators vowels consonants vowelModifiers  = 
   let -- theBlanks = getBlanks aString pauseIndicators
      aWord = wordClassTest aString "lg" pauseIndicators vowels consonants vowelModifiers 
      --nextWord = complexRootWord (drop (length theBlanks) aString) pauseIndicators vowels consonants vowelModifiers   in
-- if (length theBlanks) > 0 
--  then if length nextWord > 0
--     then theBlanks ++ nextWord
--     else []
--  else
   in
   if length aWord > 0 
      then aWord ++ complexRootWord (drop (length aWord) aString) pauseIndicators vowels consonants vowelModifiers 
      else []

-- numberStarters :: [String]
-- numberStarters = ["ki","li"]

-- number :: String -- ^ input string
--        -> [([String],[String])]
--        -> String -- ^ output first number string
-- number aString =
--   let aWord = baseWord aString
--   in
--    if elem aWord numberStarters
--       then aWord ++ numberContinuation (drop (length aWord) aString)
--       else ""
-- 
-- numberContinuation :: String -- ^ input string
--                    -> String -- ^ output first number string
-- numberContinuation aString =
--    let mWord = monoSyllable aString
--        aWord = if length mWord > 0
--                   then mWord
--                   else (head aString) : []
--    in 
--    case aWord of
--       "Nu" -> aWord ++ numberContinuation (drop 2 aString) -- 0
--       "bq" -> aWord ++ numberContinuation (drop 2 aString) -- 1 
--       "ka" -> aWord ++ numberContinuation (drop 2 aString) -- 2
--       "ji" -> aWord ++ numberContinuation (drop 2 aString) -- 3
--       "vu" -> aWord ++ numberContinuation (drop 2 aString) -- 4 
--       "mq" -> aWord ++ numberContinuation (drop 2 aString) -- 5
--       "xa" -> aWord ++ numberContinuation (drop 2 aString) -- 6
--       "zi" -> aWord ++ numberContinuation (drop 2 aString) -- 7
--       "pu" -> aWord ++ numberContinuation (drop 2 aString) -- 8
--       "du" -> aWord ++ numberContinuation (drop 2 aString) -- 8
--       "[q" -> aWord ++ numberContinuation (drop 2 aString) -- 9 
--       "gq" -> aWord ++ numberContinuation (drop 2 aString) -- 9
--       "da" -> aWord ++ numberContinuation (drop 2 aString) -- A 10
--       --"da" -> aWord ++ numberContinuation (drop 2 aString) -- A 10 
--       "gi" -> aWord ++ numberContinuation (drop 2 aString) -- B 11
--       --"gi" -> aWord ++ numberContinuation (drop 2 aString) -- B 11
--       "tu" -> aWord ++ numberContinuation (drop 2 aString) -- C 12
--       "Ni" -> aWord ++ numberContinuation (drop 2 aString) -- C 12
--       "sq" -> aWord ++ numberContinuation (drop 2 aString) -- D 13
--       "ba" -> aWord ++ numberContinuation (drop 2 aString) -- D 13
--       "\\a"-> aWord ++ numberContinuation (drop 2 aString) -- E 14
--       "kq" -> aWord ++ numberContinuation (drop 2 aString) -- E 14 
--       "wi" -> aWord ++ numberContinuation (drop 2 aString) -- F 15
--       "ju" -> aWord ++ numberContinuation (drop 2 aString) -- F 15
--       "bi" -> aWord ++ numberContinuation (drop 2 aString) -- point floating point
--       "gu" -> aWord ++ numberContinuation (drop 2 aString) -- continuing pattern ..
--       "Na" -> aWord ++ numberContinuation (drop 2 aString) -- negation sign indicator
--       "."  -> aWord ++ numberContinuation (drop 2 aString) -- binary 0
--       "q"  -> aWord ++ numberContinuation (drop 2 aString) -- binary 1
--       "Bo" -> aWord -- ending
--       "bu" -> aWord -- ending
--       _   -> ""-- ending

sentenceArgument :: String -- ^ input string
                 -> String -- ^ pauseIndicators
                 -> String -- ^ vowels
                 -> String -- ^ consonants
                 -> String -- ^ vowelModifiers
                 -> [String] -- ^ singleWordQuoteStarters
                 -> [[String]] -- ^ wordQuoteStarters
                 -> [String] -- ^ stopQuoteStarters
                 -> ([String],[(String,[String])]) -- ^ langQuoteStarters
                 -> [String] -- ^ singleWordArguments
                 -> String -- ^ output first argument
sentenceArgument []  pauseIndicators vowels consonants vowelModifiers singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters singleWordArguments = []
sentenceArgument aString pauseIndicators vowels consonants vowelModifiers  singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters singleWordArguments =
   let aWord            = baseWord aString pauseIndicators vowels consonants vowelModifiers
       aSingleWordQuote = singleWordQuote aString  singleWordQuoteStarters pauseIndicators vowels consonants vowelModifiers
       aWordQuote       = wordQuote aString pauseIndicators vowels consonants vowelModifiers  wordQuoteStarters stopQuoteStarters langQuoteStarters
       aStopQuote       = stopQuote aString pauseIndicators vowels consonants vowelModifiers  stopQuoteStarters
       aLangQuote       = langQuote aString pauseIndicators vowels consonants vowelModifiers   stopQuoteStarters langQuoteStarters
   in 
   if elem aWord singleWordArguments 
      then aWord
      else if length aSingleWordQuote > 0
         then aSingleWordQuote
         else if length aWordQuote > 0
            then aWordQuote
            else if length aStopQuote > 0
               then aStopQuote
               else if length aLangQuote > 0
                  then aLangQuote
                  else []

findArguments :: String -- ^ input string
              -> String -- ^ pauseIndicators
              -> String -- ^ vowels
              -> String -- ^ consonants
              -> String -- ^ vowelModifiers
              -> [String] -- ^ rootStarters
              -> [String] -- ^ singleWordQuoteStarters
              -> [[String]] -- ^ wordQuoteStarters
              -> [String] -- ^ stopQuoteStarters
              -> ([String],[(String,[String])]) -- ^ langQuoteStarters
              -> [String] -- singleWordArguments
              -> String -- ^ output first argument
findArguments aString pauseIndicators vowels consonants vowelModifiers rootStarters singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters singleWordArguments =
   let anArgument = sentenceArgument aString pauseIndicators vowels consonants vowelModifiers  singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters singleWordArguments
       anArgumentContinue = findArguments (drop (length anArgument) aString)  pauseIndicators vowels consonants vowelModifiers rootStarters singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters singleWordArguments 
       aRoot = getActingRoot aString pauseIndicators vowels consonants vowelModifiers  rootStarters
       aRootContinue =  findArguments (drop (length aRoot) aString)  pauseIndicators vowels consonants vowelModifiers rootStarters singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters singleWordArguments
   in 
   if length aRoot > 1 
      then  aRootContinue
      else if length anArgument >= 2
         then anArgument ++ anArgumentContinue
         else ""
   
   -- zU-mdi types:
   -- -- single word:
   --    lo rootWordComplex
   --    le rootWordComplex
   --    Zo word
   --    zy.languageLabel. text .languageLabel.
   --    la.name.
   -- -- many word:
   --    lu lU
   --    do dO
    --   let theMonoSyllable = monoSyllable aString
    --   in 
    --   case theMonoSyllable of
    --   "zy" -> wordClassTest aString "z" -- lBQ-G! string quote
    --   "zu" -> wordClassTest aString "z" -- kbq-gu string quote
    --   "ZOi"-> wordClassTest aString "z" -- foreign language quote
    --   "ky" -> wordClassTest aString "z" -- runnable text quote
    --   "gq" -> wordClassTest aString "z" -- comment quote
    --   "la" -> wordClassTest aString "m" -- lBQ-G! name
    --   "ka" -> wordClassTest aString "m" -- kbq-gu name
    --   --"lq" -> wordClassTest aString "m" -- name
    --   "li" -> wordClassTest aString "n" -- number
    --   "ki" -> wordClassTest aString "n" -- number
    --   "lq" -> theMonoSyllable ++ complexRootWord (drop 2 aString) -- an actingRoot
    --   "le" -> theMonoSyllable ++ complexRootWord (drop 2 aString) -- the actingRoot
    --   -- "ju" -> theMonoSyllable ++ complexRootWord (drop 2 aString) rootWordComplexStarter
    --   "Zo" -> theMonoSyllable ++ lBword (drop 2 aString) -- single lBQ-G! word quote
    --   "zq" -> theMonoSyllable ++ lBword (drop 2 aString) -- single kbq-gu word quote
    --   "lu" -> wordClassTest aString "w"  -- lBQ-G! quote
    --   "ku" -> wordClassTest aString "w"  -- kbq-gu quote
    --   "do" -> wordClassTest aString "w" -- lBQ-G! comment
    --   "dq" -> wordClassTest aString "w" -- kbq-gu comment
    --   _    -> "" --

findRoots :: String -- ^ input string
          -> String -- ^ pauseIndicators
          -> String -- ^ vowels
          -> String -- ^ consonants
          -> String -- ^ vowelModifiers
         -> [String] -- ^ rootStarters
         -> [String] -- ^ singleWordQuoteStarters
         -> [[String]] -- ^ wordQuoteStarters
         -> [String] -- ^ stopQuoteStarters
         -> ([String],[(String,[String])]) -- ^ langQuoteStarters
         -> [String] -- singleWordArguments
         -> String -- ^ outputs the totalRootComplex in the first sentence
findRoots aString pauseIndicators vowels consonants vowelModifiers  rootStarters singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters singleWordArguments =
   let theRoot = complexRootWord aString pauseIndicators vowels consonants vowelModifiers 
       theArgument = sentenceArgument aString pauseIndicators vowels consonants vowelModifiers  singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters singleWordArguments
       theWord = baseWord aString pauseIndicators vowels consonants vowelModifiers 
       theRootAfterWord = baseWord (drop (length theWord) aString) pauseIndicators vowels consonants vowelModifiers 
   in 
   if length theArgument > 0
      then findRoots (drop (length theArgument) aString) pauseIndicators vowels consonants vowelModifiers  rootStarters singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters singleWordArguments
      else if elem theWord rootStarters
         then theRootAfterWord ++ findRoots (drop (length theWord + length theRootAfterWord) aString) pauseIndicators vowels consonants vowelModifiers  rootStarters singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters singleWordArguments
         else if length theRoot > 0
            then theRoot ++ findRoots (drop (length theWord + length theRootAfterWord) aString) pauseIndicators vowels consonants vowelModifiers  rootStarters singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters singleWordArguments
            else []

          

getActingRoot :: String -- ^ input string
              -> String -- ^ pauseIndicators
              -> String -- ^ vowels
              -> String -- ^ consonants
              -> String -- ^ vowelModifiers
              -> [String] -- ^ rootWordStarters
              -- -> [String] -- ^ monoSyllableRoot
              -> String -- ^ output first actingRoot if found
getActingRoot [] pauseIndicators vowels consonants vowelModifiers  rootStarters = [] 
getActingRoot aString pauseIndicators vowels consonants vowelModifiers  rootStarters = 
   let theWord = baseWord aString pauseIndicators vowels consonants vowelModifiers 
       aComplexRootWord = complexRootWord aString pauseIndicators vowels consonants vowelModifiers 
   in 
   if (length aComplexRootWord > 4 ) 
      then aComplexRootWord
      else if elem theWord rootStarters
         then theWord  ++ baseWord (drop (length theWord) aString) pauseIndicators vowels consonants vowelModifiers 
         else ""
--    
--getStripedActingRoot :: String -- ^ input string
--              -> String -- ^ output first actingRoot if found
--getStripedActingRoot [] = [] 
--getStripedActingRoot aString = 
--   let theMonoSyllable = monoSyllable aString
--       locomplexRootWord = complexRootWord aString
--   in 
--   if (length locomplexRootWord > 5 ) 
--      then locomplexRootWord
--      else if theMonoSyllable == "ju"
--         then complexRootWord (drop 2 aString)
--         else ""
--


      
-- 
--allArguments :: String -- ^ input character list (string)
--             -> String -- ^ output argument list
--allArguments aString =
--   if length theBlanks > 0 
--      then allArguments (drop (length theBlanks) aString)
--      else if length aWord > 0 
--         then aWord : allArguments (drop (length aWord) aString)
--         else "":[]
--     where aWord = lBword aString
--           theBlanks =  getBlanks aString
--   
sentence :: String -- ^ input character list (string)
         -> String -- ^ pauseIndicators
         -> String -- ^ vowels
         -> String -- ^ consonants
         -> String -- ^ vowelModifiers
         -> [String] -- ^ rootStarters 
         -> [String] -- ^ singleWordQuoteStarters
         -> [[String]] -- ^ wordQuoteStarters
         -> [String] -- ^ stopQuoteStarters
         -> ([String],[(String,[String])]) -- ^ langQuoteStarters
         -> [String] -- singleWordArguments
         -> String -- ^ return first sentence
sentence [] pauseIndicators vowels consonants vowelModifiers rootStarters singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters singleWordArguments = []
sentence aString pauseIndicators vowels consonants vowelModifiers  rootStarters singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters singleWordArguments =
-- let theBlanks = getBlanks aString pauseIndicators
-- in
-- if (length theBlanks) > 0 
--  then theBlanks ++ sentence (drop (length theBlanks) aString) pauseIndicators vowels consonants vowelModifiers  rootStarters singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters
--  else
   let anActingRoot = getActingRoot aString pauseIndicators vowels consonants vowelModifiers  rootStarters 
       argument  = sentenceArgument aString  pauseIndicators vowels consonants vowelModifiers  singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters singleWordArguments
   in
   if (length argument) > 0
      then argument ++ sentence (drop (length argument) aString) pauseIndicators vowels consonants vowelModifiers   rootStarters singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters singleWordArguments
      else if (length anActingRoot) > 1
         then anActingRoot ++ sentence (drop (length anActingRoot) aString) pauseIndicators vowels consonants vowelModifiers  rootStarters singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters singleWordArguments
         else ""

-- need to make a paragraph parser
-- paragraph connectors
-- sentenceConnectors :: [String]
-- .q is "execute or run preceding text"
-- .i is "and then" dimension(time) sequentially
-- .a is "or" logically parrallel
-- .u is "and" logically parrallel
--sentenceConnectors = ["i","q","a","u"]
-- can have multiQuote style paragraphs
paragraph :: String  -- ^ input string
          -> String -- ^ pauseIndicators
          -> String -- ^ vowels
          -> String -- ^ consonants
          -> String -- ^ vowelModifiers
          -> [String] -- ^ sentence connectors
          -> [String] -- ^ rootStarters
          -> [String] -- ^ singleWordQuoteStarters
          -> [[String]] -- ^ wordQuoteStarters
          -> [String] -- ^ stopQuoteStarters
          -> ([String],[(String,[String])]) -- ^ langQuoteStarters
          -> [String] -- ^ singleWordArguments
          -> String  -- ^ output first paragraph
paragraph [] pauseIndicators vowels consonants vowelModifiers sentenceConnectors rootStarters singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters singleWordArguments = []
paragraph aString pauseIndicators vowels consonants vowelModifiers  sentenceConnectors rootStarters singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters singleWordArguments =
-- let theBlanks = getBlanks aString pauseIndicators
-- in
-- if (length theBlanks) > 0 
--  then theBlanks ++ paragraph (drop (length theBlanks) aString) pauseIndicators vowels consonants vowelModifiers  sentenceConnectors rootStarters singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters
--  else
   let firstSentence = sentence aString pauseIndicators vowels consonants vowelModifiers  singleWordQuoteStarters rootStarters wordQuoteStarters stopQuoteStarters langQuoteStarters singleWordArguments
       firstConnector = baseWord (drop (length firstSentence) aString) pauseIndicators vowels consonants vowelModifiers 
       nextParagraph = paragraph (drop ((length firstSentence)+(length firstConnector)) aString)  pauseIndicators vowels consonants vowelModifiers sentenceConnectors rootStarters singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters singleWordArguments
       restParagraph = if elem firstConnector sentenceConnectors
                           then firstConnector ++ nextParagraph
                           else [] -- "first connector: " ++ firstConnector ++ " zeND"
       firstParagraph = firstSentence ++ restParagraph
   in firstParagraph


-- findFunction :: String -- input string
--              -> String -- ^ pauseIndicators
--              -> String -- ^ vowels
--              -> String -- ^ consonants
--              -> String -- ^ vowelModifiers
--              -> [String] -- ^ sentence connectors
--              -> [String] -- ^ rootStarters
--              -> [String] -- ^ singleWordQuoteStarters
--              -> [[String]] -- ^ wordQuoteStarters
--              -> [String] -- ^ stopQuoteStarters
--              -> ([String],[(String,[String])]) -- ^ langQuoteStarters
--              -> String -- function to find 
--              -> String  -- ^ output found function sentence
-- findFunction aString pauseIndicators vowels consonants vowelModifiers  sentenceConnectors rootStarters singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters functionToFind = 
--    let firstSentence =  sentence aString pauseIndicators vowels consonants vowelModifiers  singleWordQuoteStarters rootStarters wordQuoteStarters stopQuoteStarters langQuoteStarters
--        firstConnector =  baseWord (drop (length firstSentence) aString) pauseIndicators vowels consonants vowelModifiers 
--        nextParagraph = paragraph (drop ((length firstSentence)+(length firstConnector)) aString)  pauseIndicators vowels consonants vowelModifiers sentenceConnectors rootStarters singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters
--        isSentenceConnector = if elem firstConnector sentenceConnectors
--                            then True
--                            else False -- "first connector: " ++ firstConnector ++ " zeND"
--        -- firstParagraph = firstSentence ++ restParagraph
--        theRoots = findRoots firstSentence  pauseIndicators vowels consonants vowelModifiers  rootStarters singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters
--        theFunctionList = getBaseWordList functionToFind pauseIndicators vowels consonants vowelModifiers
--        theRootList = getBaseWordList theRoots pauseIndicators vowels consonants vowelModifiers
--    in 
--    if fitsIn theFunctionList theRootList
--       then firstSentence
--       else if isSentenceConnector
--          then findFunction nextParagraph  pauseIndicators vowels consonants vowelModifiers  sentenceConnectors rootStarters singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters functionToFind 
--          else []
getBaseWordList :: String -- input string
                -> String -- pauseIndicators
                -> String -- vowels
                -> String -- consonants
                -> String -- vowelModifiers
                -> [String] -- baseWordList
getBaseWordList aString pauseIndicators vowels consonants vowelModifiers =
   let aWord = baseWord aString pauseIndicators vowels consonants vowelModifiers
       aWordContinue = getBaseWordList (drop (length aWord) aString) pauseIndicators vowels consonants vowelModifiers
   in 
   if length aWord > 1
      then aWord : aWordContinue
      else []

fitsIn :: [String] -- list of strings (potential subset)
       -> [String] -- list of strings (full set)
       -> Bool -- return true if subset
fitsIn [] theSet = True
fitsIn (x:xs) theSet =
  if elem x theSet
     then fitsIn xs theSet
     else False
   
-- ignore haskell specialized functions, it's not like we're gonna be using it for infinity

-- haskellSentence :: String -- ^ input character list (string) assumed proper sentence
--                 -> [String] -- ^ singleWordQuoteStarters
--                 -> [[String]] -- ^ wordQuoteStarters
--                 -> [String] -- ^ stopQuoteStarters
--                 -> [String] -- ^ langQuoteStarters
--                 -> ([String],[String])  -- ^ return ([ActingRootWordComplexes], [arguments/zU-mdi]) 
-- haskellSentence []  singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters = ([],[])
-- haskellSentence aString  singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters =
--  let theBlanks = getBlanks aString
--  in
--  if (length theBlanks) > 0 
--   then haskellSentence (drop (length theBlanks) aString) singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters
--   else
--    let actingRoot = getActingRoot aString
--        actingRoot1 = complexRootWord actingRoot -- check for if starts with "ju"+root will fail
--        argument  = sentenceArgument aString singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters 
--    in
--    if (length actingRoot) > 5 
--       then let actingRoot2 = fst $ haskellSentence (drop (length actingRoot) aString) singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters
--                argument2 = snd $ haskellSentence (drop (length actingRoot) aString) singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters
--            in 
--            if actingRoot == actingRoot1 
--               -- then there is no "ju" starter
--               then (actingRoot:actingRoot2, argument2)
--               -- there is a "ju" starter
--               else ((drop 2 actingRoot):actingRoot2, argument2) 
--       else if (length argument) > 2
--          then let actingRoot3 = fst $ haskellSentence ( drop (length argument) aString) singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters
--                   argument3   = snd $ haskellSentence ( drop (length argument) aString) singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters
--               in (actingRoot3, argument:argument3)
--          else ([],[])
-- 
-- haskellLangQuote :: String  -- ^ input string assumed langQuote
--                 -> [String] -- ^ langQuoteStarters
--                 -> [String] -- ^ stopQuoteStarters
--                 -> [String] -- ^ output [quoteStarter, langLabel, contents]
-- haskellLangQuote [] langQuoteStarters stopQuoteStarters = []
-- haskellLangQuote aString [] stopQuoteStarters = []
-- -- haskellLangQuote aString langQuoteStarters [] = []
-- haskellLangQuote aString langQuoteStarters stopQuoteStarters =
--    -- get theStarter
--    let theStarter = baseWord aString
--        theStopLetter = getBlanks (drop (length theStarter) aString) 
--    -- get theLanguageLabel
--        theLanguageLabelWithStop = langQuoteLanguageLabel (drop (length theStarter + length theStopLetter) aString) 
--        theLanguageLabel = take (length  theLanguageLabelWithStop - length theStopLetter) theLanguageLabelWithStop
--    -- get theContents
--        theContentsWithEndLabel = langQuoteContinuation (drop (length theStarter + length theStopLetter + length theLanguageLabelWithStop) aString) langQuoteStarters stopQuoteStarters theLanguageLabelWithStop
--        theContents =  take (length  theContentsWithEndLabel - length theStopLetter - length theLanguageLabelWithStop) theContentsWithEndLabel
--    -- return in reverse order
--    in [theStarter, theLanguageLabel, theContents]
-- 
-- haskellStopQuote :: String -- ^ input string assumed stopQuote
--                 -- -> [String] -- ^ stopQuoteStarters
--                 -> [String] -- ^ output [quoteStarter, contents] 
-- haskellStopQuote [] = []
-- haskellStopQuote aString =
--    let theStarter = baseWord aString
--        theStopLetter = getBlanks aString
--        theContentsWithEndStop = (drop (length theStarter+ length theStopLetter) aString)
--        theContents = take (length theContentsWithEndStop - (length theStopLetter)) theContentsWithEndStop
--    in [theStarter, theContents] 
-- 
-- haskellMultiQuote :: String -- ^ input string assumed multiQuote
--                  -> [String] -- ^ list of delimiters
--                  -> [String] -- ^ [quote1,quoteN]
-- haskellMultiQuote [] [] = []
-- haskellMultiQuote [] theDelimiters = []
-- haskellMultiQuote aMultiQuote [] = []
-- haskellMultiQuote aMultiQuote theDelimiters =
--    let theDelim = head theDelimiters
--        theRest = drop (length theDelim) aMultiQuote
--        theTailDelims = tail theDelimiters
--        quoteContents = haskellMultiQuoteContinuation theRest theDelimiters
--        theRest2 = drop (length quoteContents) theRest
--    in quoteContents : haskellMultiQuote theRest2 theTailDelims
--        
-- haskellMultiQuoteContinuation :: String -- ^ input string
--                               -> [String] -- ^ list of delimiters
--                               -> String -- ^ output the output up to the second delimiter
-- haskellMultiQuoteContinuation [] [] = []
-- haskellMultiQuoteContinuation [] delimiters = []
-- haskellMultiQuoteContinuation aString [] = []
-- haskellMultiQuoteContinuation aString delimiters =
--    let theWord = lBword aString
--    in -- if first delimeter 
--    if theWord == delimiters !! 0
--       --- then multiQuote aString
--      then multiQuote aString delimiters
--       --- else if second delimiter 
--      else if theWord == delimiters !! 1
--       ---- then return end
--       then []
--       ---- else return and recurse
--       else theWord ++ haskellMultiQuoteContinuation (drop (length theWord) aString) delimiters

--haskellWordQuote :: String -- ^ input string
--                 -> [String] -- ^ outputs [quote1,quoteN]
--haskellWordQuote [] = []
--haskellWordQuote aString =
--   -- get first word
--   let theWord = baseWord aString
--       theQuote = 
--       theNextQuote =
--   in
--   -- check if wordQuoteStarter
--   if elem theWord wordQuoteStarters
--   -- -- then get till next quote
--      then theQuote : theNextQuote
--   -- -- else return
--      else []



-- haskellParagraph :: String -- ^ input string
--                  -> [String] -- ^ sentenceConnectors
--                  -> [String] -- ^ singleWordQuoteStarters
--                  -> [[String]] -- ^ wordQuoteStarters
--                  -> [String] -- ^ stopQuoteStarters
--                  -> [String] -- ^ langQuoteStarters
--                  -> [String] -- ^ output haskell paragraph [sentence1,connector1,sentenceN,connectorN]
-- haskellParagraph [] sentenceConnectors  singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters = []
-- haskellParagraph aString sentenceConnectors singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters =
--    -- get the first sentence
--    let theSentence = sentence aString singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters
--    -- add to list,
--    -- get the next word, 
--        theConnector = lBword (drop (length theSentence) aString) 
--        theContinuation = haskellParagraph (drop (length theSentence + length theConnector) aString) sentenceConnectors singleWordQuoteStarters wordQuoteStarters stopQuoteStarters langQuoteStarters
--    in
--    -- check if connector, 
--    if elem theConnector sentenceConnectors
--    -- -- then add as item
--       then theSentence : theConnector : theContinuation
--    -- -- else end
--       else theSentence : []
--  let theBlanks = getBlanks aString
--  in
--  if (length theBlanks) > 0 
--   then theBlanks ++ haskellParagraph (drop (length theBlanks) aString)
--   else

