--    VALsi LOGJbang l3-\Bo ki-gb bq-Ng word tokenizing library
--    Copyright (C) 2007  Andrii Loki Zvorygin (andrii.z@gmail.com)
--
--    This program is free software: you can redistribute it and/or modify
--    it under the terms of the GNU General Public License as published by
--    the Free Software Foundation, either version 3 of the License, or
--    (at your option) any later version.
--
--    This program is distributed in the hope that it will be useful,
--    but WITHOUT ANY WARRANTY; without even the implied warranty of
--    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--    GNU General Public License for more details.
--
--    You should have received a copy of the GNU General Public License
--    along with this program.  If not, see <http://www.gnu.org/licenses/>.
module Tokenizer
   where

-- functions take a String, and output String of what they match

-- letterLength :: Int
-- letterLength = 1
-- 
-- -- | Letter -- letters
-- -- | open sound letter
-- vowels :: [Char]
-- vowels = "aAeEfFiIoOuUqQyY1!2@3#"
-- 
-- -- | closed sound letter
-- consonants :: [Char]
-- consonants = "bBdDcCgGhHjJkKlLnNmMpPrRsStTvVwWxXzZ4$5%6^7&8*9(0)[{]};:/?\'\",<_>`~\\|"
-- 
-- -- -- | stopLetter
-- stopLetter :: [Char] 
-- stopLetter = "."
-- 
-- -- | vowelEmphasis
-- vowelEmphasis = "-"
-- 
-- -- |
-- blanks = " \t\n\r\EOT"

--tbongBaseWord x = baseWord x "." "iauq" "bmdvkNzgjx" "-"


-- | Letter GIRzu -- letter groups
-- | letter class test
letterClassTest :: String  -- ^ input string
                -> String  -- ^ matching string, G is consonants, g is lower case consonants, K is large vowers, k is small vowels, ' is y'y, x ar hyphens, y is "y", d is pauses
                -> String  -- ^ pauseIndicators
                -> String  -- ^ vowels
                -> String  -- ^ consonants
                -> String  -- ^ vowelModifiers
                -> String  -- ^ output matched string
letterClassTest [] theMatchLetter pauseIndicatros vowels consonants vowelModifiers = ""
letterClassTest aString [] pauseIndicators vowels consonants vowelModifiers = ""
letterClassTest aString theMatch pauseIndicators vowels consonants vowelModifiers = case theMatch !! 0 of
  'c'  -> letterClassTestpa aString theMatch consonants pauseIndicators vowels consonants vowelModifiers --  checks that is closed sound letter
  'v'  -> letterClassTestpa aString theMatch vowels pauseIndicators vowels consonants vowelModifiers  -- do { oneOf kalrsancbardlE'u   -> abu; letterClassTest ys -> by; return (abu:by) } -- ^ checks that is open sound large letter
  '-'  -> letterClassTestpa aString theMatch vowelModifiers pauseIndicators vowels consonants vowelModifiers -- 
  --'.'  -> letterClassTestpa aString theMatch stopLetter  -- do { oneOf stopLetter           -> abu; letterClassTest ys -> by; return (abu:by) } -- ^ checks that is pausing letter
  '.'  -> letterClassTestpa aString theMatch pauseIndicators pauseIndicators vowels consonants vowelModifiers 
  _    -> "" -- fail "parser: letterClassTest: bad string, accepts: gGkK'xd"

-- | letterClassTest helper function
letterClassTestpa :: String  -- ^ input string
                  -> String  -- ^ matching string
                  -> String  -- ^ element string with which the first character of the input string is matched
                  -> String  -- ^ pauseIndicators
                  -> String  -- ^ vowels
                  -> String  -- ^ consonants
                  -> String  -- ^ vowelModifiers
                  -> String  -- ^ output string
letterClassTestpa (x:xs) (y:ys) loseCMIma pauseIndicators vowels consonants vowelModifiers = 
   if elem x loseCMIma
      then x : letterClassTest xs ys pauseIndicators vowels consonants vowelModifiers 
      else []

-- | LetterKLEsiLISteCIPra letter class list test
letterClassListTest :: String   -- ^ input string
                    -> [String] -- ^ letterClassTest matches
                    -> String   -- ^ pauseIndicators 
                    -> String   -- ^ vowels
                    -> String   -- ^ consonants
                    -> String   -- ^ vowelModifiers
                    -> String   -- ^ output first match
letterClassListTest [] theMatches pauseIndicators vowels consonants vowelModifiers = ""
letterClassListTest aString [] pauseIndicators vowels consonants vowelModifiers = ""
letterClassListTest aString (theMatch:theMatches) pauseIndicators vowels consonants vowelModifiers = 
   let loJALge = letterClassTest aString theMatch pauseIndicators vowels consonants vowelModifiers
   in 
   if length loJALge == length theMatch
      then loJALge
      else letterClassListTest aString theMatches pauseIndicators vowels consonants vowelModifiers 

-- | GISmu, root word
biSyllable :: String -- ^ input string
           -> String -- ^ vowels
           -> String -- ^ consonants
           -> String -- ^ vowelModifiers
           -> String -- ^ output string
biSyllable aString vowels consonants vowelModifiers = letterClassListTest aString ["ccv-cv","cv-ccv"] [] vowels consonants vowelModifiers

-- | CMAvo, grammar words
monoSyllable :: String -- ^ input string
             -> String -- ^ pauseIndicators
             -> String -- ^ vowels
             -> String -- ^ consonants
             -> String -- ^ vowelModifiers
             -> String -- ^ output string
monoSyllable aString pauseIndicators vowels consonants vowelModifiers = letterClassListTest aString ["cvv","cv-v","cv",".vv",".v"] pauseIndicators vowels consonants vowelModifiers

-- | RAFsi, affixes
affix :: String -- ^ input string
      -> String -- ^ vowels
      -> String -- ^ consonants
      -> String -- ^ output matched string
affix aString vowels consonants = letterClassListTest aString ["ccvc","cvcc"] [] vowels consonants [] -- ,"ggkg","gkgg"]--"ggkx","gkgx","gkkx","gk'kx"]

-- | completive RAFsi -- same as biSyllable
completiveaffix :: String -- ^ input string
                -> String -- ^ vowels
                -> String -- ^ consonants
                -> String -- ^ vowelModifiers
                -> String -- ^ output matched string
completiveaffix aString vowels consonants vowelModifiers = biSyllable aString vowels consonants vowelModifiers

-- | RAFsiKLEsiCIPra affix class test
affixClassTest :: String -- ^ input bridi
               -> String -- ^ input rafsi string, r is affix, m is completiveaffix, p is po'unfanmaffix, f is fanmaffix, l is affixCompound
               -> String -- ^ vowels
               -> String -- ^ consonants
               -> String -- ^ vowelModifiers
               -> String -- ^ output matched rafsi string
affixClassTest "" theMatch vowels consonants vowelModifiers = []
affixClassTest aString "" vowels consonants vowelModifiers = []
affixClassTest aString theMatch vowels consonants vowelModifiers = case theMatch !! 0 of
  'r'  -> affixClassTestpa aString theMatch (affix aString vowels consonants) vowels consonants vowelModifiers --  r for affix
  'm'  -> affixClassTestpa aString theMatch (completiveaffix aString vowels consonants vowelModifiers) vowels consonants vowelModifiers  --  m for completiveaffix
  'l'  -> affixClassTestpa aString theMatch (affixCompound aString vowels consonants vowelModifiers) vowels consonants vowelModifiers   --  l for affixCompound
  _    -> "" -- fail "parser: affixClassTest: bad string, accepts: rmpfl"

affixClassTestpa :: String -- ^ input bridi
                 -> String -- ^ affixClassTest match string
                 -> String -- ^ rafsi collection result
                 -> String -- ^ vowels
                 -> String -- ^ consonants
                 -> String -- ^ vowelModifiers
                 -> String -- ^ output 
affixClassTestpa [] theMatch loJALge vowels consonants vowelModifiers = []
affixClassTestpa aString [] loJALge vowels consonants vowelModifiers = []
affixClassTestpa aString theMatch [] vowels consonants vowelModifiers = [] -- if loJALge empty return nothing
affixClassTestpa aString (x:xs) loJALge vowels consonants vowelModifiers = loJALge ++ affixClassTest (drop (length loJALge) aString) xs vowels consonants vowelModifiers

-- | LUJvo, affix compound
affixCompound :: String  -- ^ input bridi
              -> String -- ^ vowels
              -> String -- ^ consonants
              -> String -- ^ vowelModifiers
              -> String  -- ^ output matched affix compound
affixCompound [] vowels consonants vowelModifiers = []
affixCompound aString vowels consonants vowelModifiers = 
   let loJALge = affixCompoundpa aString vowels consonants vowelModifiers
   in
   if length loJALge > 0
      then if elem (loJALge !! ((length loJALge) -1)) vowels
         then loJALge
         else []
      else []

-- | LUJvo helper function
affixCompoundpa :: String -- ^ input bridi
                -> String -- ^ vowels
                -> String -- ^ consonants
                -> String -- ^ vowelModifiers
                -> String -- ^ output matched affix compound
affixCompoundpa aString vowels consonants vowelModifiers = -- rafskleslistcIpra aString ["pf","rm"]
  let anRM  = affixClassTest aString "rm" vowels consonants vowelModifiers
      anRRM = affixClassTest aString "rrm" vowels consonants vowelModifiers
      anRR  = affixClassTest aString "rr"  vowels consonants vowelModifiers
  in
      if length anRM > 6
         then anRM
         else if length anRRM > 6
            then anRRM ++ affixCompound (drop (length (anRRM)) aString) vowels consonants vowelModifiers
            else if length (anRR) > 1*6
               then anRR ++ affixCompound (drop (length (anRR)) aString) vowels consonants vowelModifiers
               else ""
          

-- | LetterLISteCIPra letter list test
letterListTest :: String -- ^ input bridi
               -> String -- ^ letter match list
               -> String -- ^ output string if matched
letterListTest aString theMatch =
  let loJALge = letterListTestpa aString theMatch 
  in
   if length theMatch == length loJALge 
      then loJALge
      else ""

letterListTestpa :: String -- ^ input bridi
                -> String -- ^ letter match list
                -> String -- ^ output matched string
letterListTestpa [] theMatch = ""
letterListTestpa aString [] = ""
letterListTestpa (x:xs) (y:ys) =
   if x == y
      then x : letterListTest xs ys
      else ""

-- | LISteLetterLISteCIPra list letter list check,  
listLetterListTest :: String -- ^ input string
                  -> [String] -- ^ strings to match
                  -> String -- ^ output first result
listLetterListTest [] theMatches = ""
listLetterListTest aString [] = ""
listLetterListTest aString (theMatch:theMatches)= 
   if length (letterListTest aString theMatch) > 0 
      then theMatch
      else listLetterListTest aString theMatches

-- | CMEneLetter name letters
-- nameLetters :: String  -- ^ is a String
-- nameLetters = vowels ++ consonants  ++ vowelEmphasis

-- stopQuoteStarters :: [String]
-- stopQuoteStarters = ["la","ka","kq-kkq"]

-- | CMEne name
stopQuote :: String -- ^ input bridi
          -> String -- ^ pauseIndicators
          -> String -- ^ vowels
          -> String -- ^ consonants
          -> String -- ^ vowelModifiers
          -> [String] -- ^ stopQuoteStarters 
          -> String -- ^ output stopQuote
stopQuote [] pauseIndicators vowels consonants vowelModifiers stopQuoteStarters = []
stopQuote aString pauseIndicators vowels consonants vowelModifiers stopQuoteStarters  = 
   if elem theStarter stopQuoteStarters
      then if length theStopLetter > 0
         then if length theContinuation  > 0
            then theStarter ++ theStopLetter ++ theContinuation
            else ""
         else ""
      else ""
     where theStarter =  baseWord aString pauseIndicators vowels consonants vowelModifiers -- starts with da-NkU or jma-VO
           theStopLetter = letterClassTest (drop (length theStarter) aString) "." pauseIndicators [] [] []  -- (getBlanks (drop (length theStarter) aString)) -- follows with starting denpa `.` 
           theQuoteLetters = vowels++consonants++vowelModifiers
           theContinuation  = (stopQuoteContinuation (drop (length theStarter + length theStopLetter) aString) pauseIndicators theQuoteLetters) -- rest of stopQuote


-- | CMEnepa helper function
stopQuoteContinuation :: String -- ^ input bridi
                      -> String -- ^ pauseIndicator
                      -> String -- ^ quoteLetters
                      -> String -- ^ output end of stopQuote
stopQuoteContinuation [] pauseIndicator quoteLetters = []
stopQuoteContinuation (x:xs) pauseIndicator quoteLetters = 
-- with nesting (not all names valid):
-- -- get word, check if elem langQuoteStarters
--   let theWord = baseWord aString
--       theFirstLetter = aString !! 0 :[]
--       thePostWordStopLetter = getBlanks (drop (length theWord) aString)
--   in 
--   if (length theWord) > 0
--      then if elem theWord langQuoteStarters && length thePostWordStopLetter > 0
--        --       then start langQuote
--              then let theLangQuote = langQuote aString
--                   in theLangQuote ++ stopQuoteContinuation (drop (length theLangQuote) aString)
--        --       else if elem stopQuoteStarters
--              else if elem theWord stopQuoteStarters && length thePostWordStopLetter > 0
--        --          then start stopQuote
--                 then let theStopQuote = stopQuote aString
--                      in theStopQuote ++ stopQuoteContinuation (drop (length theStopQuote) aString) 
--               -- otherwise recurse
--                 else theWord ++ stopQuoteContinuation (drop (length theWord) aString) 
--        --             else if first letter of aString is stopLetter 
--      else if elem (head theFirstLetter) blanks
--         -- then it is end of quote
--         then theFirstLetter
--         -- else recurse
--         else theFirstLetter ++ stopQuoteContinuation (drop (length theFirstLetter) aString)
--           then check if rest is languageLabel
--         then let theLabel = langQuoteLanguageLabel (drop 1 aString)
--              in
--              if theLabel == languageLabel
--                 then theFirstLetter ++ theLabel
----                 else error as not stopQuote or langQuote (maybe extra stopLetter)
--                 else theFirstLetter ++ langQuoteContinuation (drop (1) aString) languageLabel
-- otherwise recurse
--         else theFirstLetter ++ langQuoteContinuation (drop (1) aString) languageLabel

-- without nesting
   if elem x quoteLetters -- if  x is a name letter
      then x : stopQuoteContinuation xs pauseIndicator quoteLetters -- then return and recurse
      else if elem x pauseIndicator -- if x is '.'  or stopLetter
         then x:[]
         else ""

-- langQuoteStarters :: [String]
-- langQuoteStarters = ["zu","gq","zy","ky","ZOi","kkq-kq"]

   
-- | ZOJre quote,  zoi (quote-label) quote material (quote-label)
langQuote :: String  -- ^ input bridi
          -> String -- ^ pauseIndicators
          -> String -- ^ vowels
          -> String -- ^ consonants 
          -> String -- ^ vowelModifiers
          -> [String] -- ^ stopQuoteStarters
          -> ([String],[(String,[String])]) -- ^ ([langQuoteStarters],[(languageLabel,[languageLetters])])
          -> String  -- ^ output language string literal
langQuote [] pauseIndicators vowels consonants vowelModifiers stopQuoteStarters langQuoteDefinition = []
langQuote aString pauseIndicators vowels consonants vowelModifiers stopQuoteStarters langQuoteDefinition = 
   if elem theStarter langQuoteStarters -- FIX: move shit to where clauses
      then if (length theStopLetter) > 0
         then if (length theLanguageLabel) > 0 -- languageLabel.
            then if (length theQuoteContents) > 0
               then  theStarter ++ theStopLetter ++ theLanguageLabel ++ theStopLetter ++ theQuoteContents
               else ""
            else ""
         else ""
      else ""
    where theStarter = baseWord aString pauseIndicators vowels consonants vowelModifiers -- starts with da-NkU or jma-VO
          theStopLetter = letterClassTest (drop (length theStarter) aString) "." pauseIndicators [] [] [] -- (getBlanks (drop (length theStarter) aString))
          langQuoteStarters = fst langQuoteDefinition
          alphabetDefinitions = snd langQuoteDefinition
          theAlphabetDefinition = langQuoteLanguageLabel (drop ((length theStarter)+(length theStopLetter)) aString) alphabetDefinitions pauseIndicators vowels consonants vowelModifiers
          theLanguageLabel = fst theAlphabetDefinition
          theLanguageLetters = snd theAlphabetDefinition
          theLangPause = theLanguageLetters !! 0
          theLangVowels = theLanguageLetters !! 1
          theLangConsonants = theLanguageLetters !! 2
          theLangModifiers = theLanguageLetters !! 3 
          -- with nesting -- theQuoteContents = langQuoteContinuation (drop ((length theStarter) + (length theStopLetter)*2 + (length theLanguageLabel)) aString) theLanguageLabel theLangPause theLangVowels theLangConsonants theLangModifiers  stopQuoteStarters  langQuoteDefinition
          theQuoteContents = langQuoteContinuation (drop ((length theStarter) + (length theStopLetter)*2 + (length theLanguageLabel)) aString) pauseIndicators theLanguageLabel

langQuoteLanguageLabel :: String -- ^ input bridi
                       -> [(String,[String])] -- ^ alphabetDefinitions (languageLabel,[pauseIndicators,vowels,consonants,vowelModifiers]) 
                       -> String -- ^ pauseIndicators
                       -> String -- ^ vowels
                       -> String -- ^ consonants
                       -> String -- ^ vowelModifiers
                       -> (String,[String]) -- ^ (languageLabel,languageLetters) output quote type aka telangQuote
langQuoteLanguageLabel aString  alphabetDefinitions pauseIndicators vowels  consonants vowelModifiers =
   let theCurrentLabelWithPause = stopQuoteContinuation aString pauseIndicators (vowels ++ consonants ++ vowelModifiers)
       theCurrentLabel = take (length theCurrentLabelWithPause -1) theCurrentLabelWithPause 
       theLanguageLabels = map fst alphabetDefinitions
       theLanguageLetters = map snd alphabetDefinitions
   in
   if elem theCurrentLabel theLanguageLabels
      then (theCurrentLabel, theLanguageLetters !! getIndex theCurrentLabel theLanguageLabels)
      else (theCurrentLabel, [pauseIndicators,vowels,consonants,vowelModifiers])

getIndex :: Eq a => a   -- input item
         -> [a] -- list to check
         -> Int -- output index integer, negative number if not found
getIndex inputItem [] = minBound :: Int
getIndex inputItem (curItem:restItems) =
    if inputItem == curItem
       then 0
       else 1 + getIndex inputItem restItems

-- -- with nesting:
-- langQuoteContinuation :: String -- ^ input bridi
--                       -> String -- ^ languageLabel
--                       -> String -- ^ pauseIndicators
--                       -> String -- ^ vowels
--                       -> String -- ^ consonants
--                       -> String -- ^ vowelModifiers
--                       -> [String] -- ^ stopQuoteStarters
--                       -> ([String],[(String,[String])]) -- ^ langQuoteStarters
--                       -> String -- ^ output quote, end with languageLabel
-- langQuoteContinuation [] languageLabel pauseIndicators vowels consonants vowelModifiers stopQuoteStarters langQuoteStarters  = ""
-- langQuoteContinuation aString languageLabel pauseIndicators vowels consonants vowelModifiers stopQuoteStarters langQuoteStarters  = 
-- -- -- get word, check if elem langQuoteStarters
--    let theWord = baseWord aString pauseIndicators vowels consonants vowelModifiers
--        allLetters = pauseIndicators++vowels++consonants++vowelModifiers
--        theFirstLetter = letterClassTest aString "." pauseIndicators vowels consonants vowelModifiers
--        thePostWordStopLetter = letterClassTest (drop (length theWord) aString) "." pauseIndicators vowels consonants vowelModifiers
--    in 
-- --    if length theFirstLetter > 0
-- --       then stopQuoteContinuation (drop (length thePostWord
--    if (length theWord) > 0
--       then if elem theWord (fst langQuoteStarters) && length thePostWordStopLetter > 0
--         --       then start langQuote
--               then let theLangQuote = langQuote aString pauseIndicators vowels consonants vowelModifiers stopQuoteStarters langQuoteStarters 
--                    in theLangQuote ++ langQuoteContinuation (drop (length theLangQuote) aString)  languageLabel pauseIndicators vowels consonants vowelModifiers stopQuoteStarters langQuoteStarters 
--         --       else if elem stopQuoteStarters
--               else if elem theWord stopQuoteStarters && length thePostWordStopLetter > 0
--         --          then start stopQuote
--                  then let theStopQuote = stopQuote aString pauseIndicators vowels consonants vowelModifiers stopQuoteStarters
--                       in theStopQuote ++ langQuoteContinuation (drop (length theStopQuote) aString) languageLabel pauseIndicators vowels consonants vowelModifiers stopQuoteStarters langQuoteStarters
--                -- otherwise recurse
--                  else theWord ++ langQuoteContinuation (drop (length theWord) aString) languageLabel pauseIndicators vowels consonants vowelModifiers stopQuoteStarters langQuoteStarters
--         --             else if first letter of aString is stopLetter 
--       else if length thePostWordStopLetter > 0
-- --           then check if rest is languageLabel
--          then let theLabelWithStop = stopQuoteContinuation (drop (length thePostWordStopLetter) aString) pauseIndicators (vowels++consonants++vowelModifiers)
--                   theLabel = take (length theLabelWithStop -1) theLabelWithStop
--               in
--               if theLabel == languageLabel
--                  then theFirstLetter ++ theLabel
-- --                 else error as not stopQuote or langQuote (maybe extra stopLetter)
--                  else theFirstLetter ++ langQuoteContinuation (drop (1) aString) languageLabel pauseIndicators vowels consonants vowelModifiers stopQuoteStarters langQuoteStarters 
-- -- otherwise recurse
--          else theFirstLetter ++ langQuoteContinuation (drop (1) aString) languageLabel pauseIndicators vowels consonants vowelModifiers stopQuoteStarters langQuoteStarters 

-- without nesting:
langQuoteContinuation :: String -- input String
                      -> String -- pauseIndicators
                      -> String -- languageLabel
                      -> String -- output
langQuoteContinuation (aLetter:aString) pauseIndicators languageLabel =  -- FIX: move shit to where clauses
  let theLanguageLabel = letterListTest aString languageLabel
      thePostLanguageLabelPause = take 1 ( drop (length theLanguageLabel) aString)
  in
   if elem aLetter pauseIndicators -- if aLetter is a glotal stop
      then if length theLanguageLabel > 0 -- 
         then aLetter : theLanguageLabel ++ thePostLanguageLabelPause
         else aLetter : langQuoteContinuation aString pauseIndicators languageLabel
      else aLetter : langQuoteContinuation aString pauseIndicators languageLabel


-- | getBlanks
getBlanks :: String -- ^ input bridi
          -> String -- ^ pauseIndicators
          -> String -- ^ output blanks matched
getBlanks [] pauseIndicators = []
getBlanks (aLetter:aString) pauseIndicators  =  
   if elem aLetter  pauseIndicators 
      then aLetter: getBlanks aString pauseIndicators
      else ""

-- | VALsiKLEsiCIPra word class test
wordClassTest :: String -- ^ input bridi
              -> String -- ^ match string: c is monoSyllable, g is biSyllable, l is affixCompound, m is stopQuote, z is langQuote
              -> String -- ^ pauseIndicators
              -> String -- ^ vowels
              -> String -- ^ consonants
              -> String -- ^ modifiers
              -> String -- ^ output of word(s) matched
wordClassTest aString [] pauseIndicators vowels consonants vowelModifiers = ""
wordClassTest [] theMatch pauseIndicators vowels consonants vowelModifiers = ""
wordClassTest aString theMatch pauseIndicators vowels consonants vowelModifiers = case theMatch !! 0 of
   'c' -> wordClassTestpa aString theMatch (monoSyllable aString pauseIndicators vowels consonants vowelModifiers) pauseIndicators vowels consonants vowelModifiers 
   'g' -> wordClassTestpa aString theMatch (biSyllable aString vowels consonants vowelModifiers) pauseIndicators vowels consonants vowelModifiers 
   'l' -> wordClassTestpa aString theMatch (affixCompound aString vowels consonants vowelModifiers) pauseIndicators vowels consonants vowelModifiers 
   -- 'm' -> wordClassTestpa aString theMatch (stopQuote aString ["ka","la"])
   -- 'z' -> wordClassTestpa aString theMatch (langQuote aString ["zu","zy","ky","gq"] ["ka","la"])
--   't' -> wordClassTestpa aString theMatch (complexRootWord aString pauseIndicators vowels consonants vowelModifiers)  pauseIndicators vowels consonants vowelModifiers 
   -- 'n' -> wordClassTestpa aString theMatch (wordQuote aString [["ki","bu"]) -- number
   -- 'f' -> wordClassTestpa aString theMatch (wordQuote aString [["ki","bi","bu"],["li","bi","Bo"]]) -- floating point number
   -- 'w' -> wordClassTestpa aString theMatch (wordQuote aString [["ku","bq"],["dq","ga"],["lu","lU"],["do","dO"],["ki","bu"],["li","Bo"]]) -- word quotes
   '.' -> wordClassTestpa aString theMatch (getBlanks aString pauseIndicators) pauseIndicators vowels consonants vowelModifiers -- other
   _   -> ""

wordClassTestpa :: String -- ^ input string
                -> String -- ^ set of matches
                -> String -- ^ word result of match
                -> String -- ^ pauseIndicators
                -> String -- ^ vowels
                -> String -- ^ consonants
                -> String -- ^ modifiers
                -> String -- ^ output string
wordClassTestpa [] theMatches aWord pauseIndicators vowels consonants vowelModifiers = ""
wordClassTestpa aString [] aWord pauseIndicators vowels consonants vowelModifiers = ""
wordClassTestpa aString (theMatch:theMatches) [] pauseIndicators vowels consonants vowelModifiers = wordClassTest aString theMatches pauseIndicators vowels consonants vowelModifiers 
wordClassTestpa aString theMatches aWord pauseIndicators vowels consonants vowelModifiers = aWord





             


baseWord :: String -- ^ input string
         -> String -- ^ pauseIndicators
         -> String -- ^ vowels
         -> String -- ^ consonants
         -> String -- ^ vowelsModifiers
         -> String -- ^ output first complexRoot or smallWord
baseWord aString pauseIndicators vowels consonants vowelModifiers  = wordClassTest aString "lgc" pauseIndicators vowels consonants vowelModifiers 

-- |  all words
-- allWords :: String   -- ^ input character list (string)
--           -> [String] -- ^ output list of words
-- allWords [] = []
-- allWords aString = 
--    if length theBlanks > 0 
--       then allWords (drop (length theBlanks) aString)
--       else if length aWord > 0 
--          then aWord : allWords (drop (length aWord) aString)
--          else "":[]
--      where aWord = baseWord aString
--            theBlanks =  getBlanks aString
